﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Monocle;
using System.Collections;

namespace Celeste.Mario.OneDashOne {
    public class CS_MarioFlagpole : CutsceneEntity {

        private Player player;
        private float entrance;

        public CS_MarioFlagpole(Player player, float entrance)
            : base(false, true) {
            this.player = player;
            this.entrance = entrance;
        }

        public override void OnBegin(Level level) {
            level.RegisterAreaComplete();
            Add(new Coroutine(Cutscene(level)));
        }

        private IEnumerator Cutscene(Level level) {
            Audio.Stop(Audio.CurrentMusicEventInstance, false);

            player.StateMachine.State = Player.StDummy;
            player.Dashes = 1;
            player.Facing = Facings.Right;
            player.ForceCameraUpdate = true;

            while (!player.OnGround())
                yield return null;

            yield return 0.1f;
            player.Facing = Facings.Left;
            yield return 0.3f;

            Audio.SetMusic("event:/music/lvl_mario_1-1/end");
            yield return player.DummyWalkTo(entrance);

            yield return 2f;

            EndCutscene(level, true);
        }

        public override void OnEnd(Level level) {
            level.CompleteArea();
        }

    }
}
